/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel  
 * 
 *  Copyright (C) 2000-2002 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  Copyright (C) 2005 by Freelines CO.,Ltd
 *
 *  Copyright (C) 2010 by Meika Sugimoto
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 */

/*
 *	ץå¸⥸塼 ֥V850ѡ
 */

#include "v850asm.inc"

#define	TOPPERS_MACRO_ONLY
#define UINT_C(val)			(val)		/* uint_tޥ */
#define ULONG_C(val)		(val)		/* ulong_tޥ */
#define CAST(type, val)		(val)		/* 㥹ȤԤޥ */
#define TOPPERS_LABEL_ASM
#include "kernel_impl.h"
#include "offset.h"

/*  */
	.globl	_set_intpri
	.globl	_call_texrtn

/*
 *	ǥѥåγ
 *
 *	߶ػ߾֡lock_flag = trueǤؤϤäƤ뤬
 *	ߥޥ٥0Ǥ뤿ᡤCPUå֤
 *	ꤷƺǽΥǥѥå˰ܤ롥
 *	
 */
	.globl	_start_dispatch
_start_dispatch:
	/* ߥޥ٥CPUå֤ͤ */
	mov		INTPRI_LOCK , r6
	jarl	_set_intpri , lp
	/* ߶ػ߾֤ */
	ei
	/* ǥѥåΤ */
	br		dispatcher

/*
 *  ǥѥå
 */
 	.globl	_dispatch
 	.globl	_exit_and_dispatch
_dispatch:
	/*
	 * ƥȤ 
	 */
	addi	-60, sp, sp
	st.w	ep , 0[sp]
	mov		sp, ep
	sst.w	r2,  56[ep]
	sst.w	r10, 52[ep]
	sst.w	r11, 48[ep]
	sst.w	r20, 44[ep]
	sst.w	r21, 40[ep]
	sst.w	r22, 36[ep]
	sst.w	r23, 32[ep]
	sst.w	r24, 28[ep]
	sst.w	r25, 24[ep]
	sst.w	r26, 20[ep]
	sst.w	r27, 16[ep]
	sst.w	r28, 12[ep]
	sst.w	r29,  8[ep]
	sst.w	r31,  4[ep]
	
	/* åȼεưϤ¸ */
	Lea		_p_runtsk, ep
	sld.w	0[ep], ep
	sst.w	sp, TCB_sp[ep]
	Lea		dispatch_r, r10
	sst.w	r10, TCB_pc[ep]
	
	/*
	 *  ǥѥå
	 *  
	 *  CPUå֡ǥѥåνñ̤
	 *  ƥѤߤ֤ɬפ.
	 */
_exit_and_dispatch:
dispatcher:
	Lea		_p_runtsk, r21
#ifdef LOG_DSP_ENTER
	mov		r21 , r10	/* p_runtsk */
	jarl	_log_dsp_enter , r31
#endif	/* LOG_DSP_ENTER */
	Lea		_p_schedtsk, r20
	ld.w	0[r20], r22
	st.w	r22, 0[r21]
	cmp		r22 , r0
	be		pre_idle
	/* åȼεưϤ */
	mov		r22, ep
	sld.w	TCB_pc[ep], r31
	sld.w	TCB_sp[ep], sp
#ifdef LOG_DSP_LEAVE
	mov		r21 , r6	/* p_runtsk */
	jarl	_log_dsp_enter , r31
#endif	/* LOG_DSP_LEAVE */
	jmp	r31

	/*
	 * ɥ롼
	 */
pre_idle:
	/* ߥåڤؤ */
	Lea		STACKTOP, sp
	/* CPUå֤β */
	Lea		_lock_flag , r10
	st.w	r0 , 0[r10]
	di
	mov		INTPRI_ENAALL , r6
	jarl	_set_intpri , lp
	/* intnest1ˤ */
	mov		1, r10
	Lea		_intnest, r11
	st.b	r10, 0[r11]
	/* reqflgΥɥ쥹 */
	Lea		_reqflg , r20
idle_loop:	
	/* Ԥ */
	ei
	nop
	di
	
	/* reqflgΥå */
	ld.w	0[r20], r10
	cmp		r10 , r0
	be		idle_loop
	
	/* reqflgΥꥢ */
	st.w	r0 , 0[r20]
	
	/* intnest򥯥ꥢ */
	Lea		_intnest, r10
	st.b	r0, 0[r10]
	/* CPUå֤ذܹ */
	di
	mov		INTPRI_LOCK , r6
	jarl	_set_intpri , lp
	ei
	/* ǥѥå */
	br	dispatcher
	
	/* ǥѥå롼 */
dispatch_r:
	Lea		_p_runtsk, r10
	ld.w	0[r10], r10
	ld.w	TCB_enatex[r10], r11
	mov		(1 << TCB_enatex_bit) , r12
	tst		r11 , r12
	bz		ret_to_task
	ld.w	TCB_texptn[r10], r11
	cmp		r0, r11
	be		ret_to_task

	/* 㳰θƤӽФ */
	jarl	_call_texrtn, lp
ret_to_task:
	mov		sp, ep
	sld.w	56[ep], r2
	sld.w	52[ep], r10
	sld.w	48[ep], r11
	sld.w	44[ep], r20
	sld.w	40[ep], r21
	sld.w	36[ep], r22
	sld.w	32[ep], r23
	sld.w	28[ep], r24
	sld.w	24[ep], r25
	sld.w	20[ep], r26
	sld.w	16[ep], r27
	sld.w	12[ep], r28
	sld.w	 8[ep], r29
	sld.w	 4[ep], r31
	addi	60, ep, sp
	ld.w	0[sp], ep
	jmp		lp

/*
 *  ư
 */
 	.globl _start_r
_start_r:
	/* ߥޥ٥CPUå֤ͤ */
	di
	mov		INTPRI_ENAALL , r6
	jarl	_set_intpri , lp
	Lea		_lock_flag , r6
	st.w	r0 , 0[r6]
	
	Lea		_p_runtsk, ep
	ld.w	0[ep], ep
	ld.w	TCB_p_tinib[ep], ep
	ld.w	TINIB_exinf[ep], r6
	ld.w	TINIB_task[ep], r10
	Lea		_ext_tsk, r31
	
	
	/* Τ */
	ei		/* ߶ػ߾֤ */
	jmp		r10

/*
 *  ߥϥɥ
 *
 *  λǥå80byteʬݤƤꡤ쥸˳ߥϥɥ
 *  ǼƤ롥
 *
 *  - r10ߥϥɥ饢ɥ쥹
 *  - r11ͥ(ɽ)
 *  - r12ߥϥɥֹ
 *
 *  åιϰʲΤȤꡥ
 *
 *    |----------------|<- ȯSP
 * 76 | current_intpri |
 *    |----------------|
 * 72 |       r1       |
 *    |----------------|
 * 68 |       r6       |
 *    |----------------|
 * 64 |       r7       |
 *    |----------------|
 * 60 |       r8       |
 *    |----------------|
 * 56 |       r9       |
 *    |----------------|
 * 52 |      r10       |
 *    |----------------|
 * 48 |      r11       |
 *    |----------------|
 * 44 |      r12       |
 *    |----------------|
 * 40 |      r13       |
 *    |----------------|
 * 36 |      r14       |
 *    |----------------|
 * 32 |      r15       |
 *    |----------------|
 * 28 |      r16       |
 *    |----------------|
 * 24 |      r17       |
 *    |----------------|
 * 20 |      r18       |
 *    |----------------|
 * 16 |      r19       |
 *    |----------------|
 * 12 |      r30       |
 *    |----------------|
 *  8 |      r31       |
 *    |----------------|
 *  4 |      EIPC      |
 *    |----------------|
 *  0 |     EIPSW      |
 *    |----------------|<- ȯSP - 80
 */
	.globl interrupt
interrupt:
	/*
	 *  ĤΥ쥸 EPǤΥڤؤƹԤ
	 *  (r10-r12Ѥ)
	 */
	st.w	ep,   12[sp]
	mov		sp ,  ep 
	sst.w	r1 ,  72[ep]
	sst.w	r6 ,  68[ep]
	sst.w	r7 ,  64[ep]
	sst.w	r8 ,  60[ep]
	sst.w	r9 ,  56[ep]
	sst.w	r13 , 40[ep]
	sst.w	r14 , 36[ep]
	sst.w	r15 , 32[ep]
	sst.w	r16 , 28[ep]
	sst.w	r17 , 24[ep]
	sst.w	r18 , 20[ep]
	sst.w	r19 , 16[ep]
	sst.w	r31 ,  8[ep]
	/* ¿ųߤΤᡤߤEIPCEIPSW¸ */
	stsr	eipc,   r6
	sst.w	r6 ,   4[ep]
	stsr	eipsw,  r6
	sst.w	r6 ,   0[ep]
	
	Lea		_lock_flag , r7
	ld.w	0[r7] , r7
	
	/* ȯγߥ٥¸ȯγߥ٥(r11)˽񤭴 */
	Lea		_current_intpri , r13
	ld.bu	0[r13] , r14
	sst.w	r14 , 76[ep]
	st.b	r11 , 0[r13]
	
	/* ¿ųߥåȥͥȥ󥿤򥤥󥯥 */
	Lea		_intnest, r13
	ld.bu	0[r13], r6
	add		1, r6
	st.b	r6, 0[r13]
	cmp		1 , r6
	bne		call_int_handler
save_tsksp:
	/* ߤǤХå򥫡ͥ륹åڤؤ */
	mov		sp , r13
	mov		STACKTOP , sp
	add		-4 , sp
	st.w	r13 , 0[sp]
call_int_handler:
#ifdef LOG_INH_ENTER
	/* ߥϥɥ饢ɥ쥹ͥ١ֹ */
	add		-8 , sp
	st.w	r10 , 0[sp]
	st.w	r12 , 4[sp]
	mov		r12 , r6
	ei
	jarl	_log_inh_enter , lp
	di
	ld.w	0[sp] , r10
	ld.w	4[sp] , r12
	add		8 , sp
#endif	/* LOG_INH_ENTER */
#ifdef LOG_INH_LEAVE
	add		-4 , sp
	st.w	r12 , 0[sp]
#endif	/* LOG_INH_LEAVE */
	Lea		end_int_handler, r31
	/* ߵ */
	ei
	/* ϥɥ鵯ư */
	jmp		r10
end_int_handler:
	/* ߶ػ */
	di
#ifdef LOG_INH_LEAVE
	ld.w	0[sp] , r6
	add		4 , sp
	ei
	jarl	_log_inh_leave , lp
	di
#endif	/* LOG_INH_LEAVE */
	/* CPUå֤򥢥å֤᤹ */
	Lea		_lock_flag , r10
	st.w	r0 , 0[r10]
	/* intnestǥ */
	Lea		_intnest, r11
	ld.bu	0[r11], r10
	add		-1 , r10
	st.b	r10, 0[r11]
	cmp		r0 , r10
	be		check_reqflg
return_from_int:
	/*
	 * 쥸 
	 */
	mov		sp , ep	/* EPڤؤ */
	Lea		_current_intpri , r10
	sld.w	76[ep] , r6
	st.b	r6 , 0[r10]
	jarl	_set_intpri , lp
	
	sld.w	 4[ep] , r10
	ldsr	r10 , eipc
	sld.w    0[ep] , r10
	ldsr    r10 , eipsw
	sld.w	72[ep] , r1
	sld.w	68[ep] , r6
	sld.w	64[ep] , r7
	sld.w	60[ep] , r8
	sld.w	56[ep] , r9
	sld.w	52[ep] , r10
	sld.w	48[ep] , r11
	sld.w	44[ep] , r12
	sld.w	40[ep] , r13
	sld.w	36[ep] , r14
	sld.w	32[ep] , r15
	sld.w	28[ep] , r16
	sld.w	24[ep] , r17
	sld.w	20[ep] , r18
	sld.w	16[ep] , r19
	sld.w	 8[ep] , r31
	addi	80 , ep, sp
	sld.w	12[ep] , r30
	
	reti	/* ߸ */

check_reqflg:
	/* å */
	ld.w	0[sp], sp
	/* 
	 * ǥѥå׵᤬뤫
	 */
	Lea		_reqflg, r10
	ld.w	0[r10], r11
	cmp		r0, r11
	be		return_from_int
	st.w	r0, 0[r10]			/* reqflgΥꥢ */
	
	/*
	 * ߤˤȤʤǥѥåȽ
	 */
	/* ǥѥåǽ֤å */
	Lea		_dspflg , r10
	ld.w	0[r10], r10
	cmp		r0, r10
	be		int_call_texrtn
	
	/* ڤؤɬפ뤫å */
	Lea		_p_schedtsk, r10
	ld.w	0[r10], r10
	Lea		_p_runtsk, r11
	ld.w	0[r11], r11
	cmp		r10,r11
	bne		ret_int

int_call_texrtn:
	/* 㳰ȯƤ뤫Υåȥ㳰롼μ¹ */
	ld.w	TCB_enatex[r11] , r11
	mov		(1 << TCB_enatex_bit) , r12
	tst		r11 , r12
	bz		return_from_int
	ld.w	TCB_texptn[r10] , r11
	cmp		r0, r11
	bz		return_from_int
	jarl	_call_texrtn , lp
	br		return_from_int

/*
 *  󥹥å쥸򤹤
 *
 *    |------------------|<- ȯSP - 80
 * 40 |        r2        |
 *    |------------------|
 * 36 |       r20        |
 *    |------------------|
 * 32 |       r21        |
 *    |------------------|
 * 28 |       r22        |
 *    |------------------|
 * 24 |       r23        |
 *    |------------------|
 * 20 |       r24        |
 *    |------------------|
 * 16 |       r25        |
 *    |------------------|
 * 12 |       r26        |
 *    |------------------|
 *  8 |       r27        |
 *    |------------------|
 *  4 |       r28        |
 *    |------------------|
 *  0 |       r29        |
 *    |------------------|<- ȯSP - 80 - 44
 */      
	.globl	ret_int
ret_int:
	addi	-44, sp, sp
	mov		sp , ep
	sst.w	r2 ,  40[ep]
	sst.w	r20 , 36[ep]
	sst.w	r21 , 32[ep]
	sst.w	r22 , 28[ep]
	sst.w	r23 , 24[ep]
	sst.w	r24 , 20[ep]
	sst.w	r25 , 16[ep]
	sst.w	r26 , 12[ep]
	sst.w	r27 ,  8[ep]
	sst.w	r28 ,  4[ep]
	sst.w	r29 , 0[ep]
	
	/* TCBȤ */
	Lea		_p_runtsk, r10
	ld.w	0[r10], r10
	st.w	sp , TCB_sp[r10]
	Lea		ret_int_r, r11
	st.w	r11 , TCB_pc[r10]
	
	/* CPUå֤ */
	mov		INTPRI_LOCK , r6
	jarl	_set_intpri , lp
	Lea		_current_intpri , r6	/* ߤβ۾γͥ٤0 */
	st.b	r0 , 0[r6]
	mov		1 , r7
	Lea		_lock_flag , r6			/* åե饰true */
	st.w	r7 , 0[r6]
	
	/* ǥѥå */
	ldsr	r0, eipsw	/* ߤϵľ֤Ǥ褤 */
	Lea		dispatcher, r10
	ldsr	r10, eipc
	reti

	.globl ret_int_r
ret_int_r:
	/* CPUåե饰β */
	Lea		_lock_flag , r6
	st.w	r0 , 0[r6]
	
	/* 㳰θƤӽФ */
	Lea		_p_runtsk , r10
	ld.w	0[r10] , r10
	ld.w	TCB_enatex[r10] , r11
	mov		(1 << TCB_enatex_bit) , r12
	tst		r11 , r12
	bz		ret_int_r_1
	ld.w	TCB_texptn[r10] , r11
	cmp		r0, r11
	bz		ret_int_r_1
	
	/* 㳰롼θƤӽФ */
	jarl	_call_texrtn , lp
ret_int_r_1:
	/* 󥹥å쥸 */
	mov		sp, ep
	sld.w	40[ep], r2
	sld.w	36[ep], r20
	sld.w	32[ep], r21
	sld.w	28[ep], r22
	sld.w	24[ep], r23
	sld.w	20[ep], r24
	sld.w	16[ep], r25
	sld.w	12[ep], r26
	sld.w	 8[ep], r27
	sld.w	 4[ep], r28
	sld.w	 0[ep], r29
	addi	44 , ep, sp
	
	/* ȤФ */
	br		return_from_int

/*
 *  CPU㳰
 *
 *  CPU㳰ȯp_excinf˳Ǽϰʲ̤ꡥ
 *  offset:0 CPU㳰ȯȯPC
 *  offset:4 CPU㳰ȯSP
 *  offset:8 CPU㳰ȯPSW
 *  offset:12 㳰
 */

	.globl	exception
exception:
	/*
	 *  ĤΥ쥸 EPǤΥڤؤƹԤ
	 *  (r10-r12Ѥ)
	 */
	st.w	ep,   16[sp]
	mov		sp ,  ep 
	sst.w	r1 ,  72[ep]
	sst.w	r6 ,  68[ep]
	sst.w	r7 ,  64[ep]
	sst.w	r8 ,  60[ep]
	sst.w	r9 ,  56[ep]
	sst.w	r13 , 40[ep]
	sst.w	r14 , 36[ep]
	sst.w	r15 , 32[ep]
	sst.w	r16 , 28[ep]
	sst.w	r17 , 24[ep]
	sst.w	r18 , 20[ep]
	sst.w	r19 , 12[ep]
	sst.w	r31 ,  8[ep]
	/* ¿㳰ΤᡤߤEIPCEIPSW¸ */
	stsr	eipc,   r6
	sst.w	r6 ,   4[ep]
	stsr	eipsw,  r6
	sst.w	r6 ,   0[ep]
	/* ȯγߥ٥¸ */
	Lea		_current_intpri , r13
	ld.bu	0[r13] , r14
	sst.w	r14 , 76[ep]
	
	/* ¿ų/㳰åȥͥȥ󥿤򥤥󥯥 */
	Lea		_intnest, r13
	ld.bu	0[r13], r6
	add		1, r6
	st.b	r6, 0[r13]
	cmp		1 , r6
	bne		set_excinf
	
exc_save_tsksp:
	/* ߤǤХå򥫡ͥ륹åڤؤ */
	mov		sp , r13
	mov		STACKTOP , sp
	add		-4 , sp
	st.w	r13 , 0[sp]
	
set_excinf:
	/* CPU㳰򥹥å˳Ǽ */
	addi	-20 , sp , sp
	mov		sp , r6
	stsr	0 , r13				/* CPU㳰ȯEIPC */
	st.w	r13 , 0[r6]
	stsr	1 , r13				/* CPU㳰ȯEIPSW */
	st.w	r13 , 8[r6]
	stsr	4 , r13
	mov		0x0000ffff , r14	/* CPU㳰ȯEICC(ECRβ16bit) */
	and		r14 , r13
	st.w	r13 , 12[r6]
	st.w	r11 , 4[r6]			/* CPU㳰ȯsp */
	Lea		_lock_flag , r14
	ld.w	0[r14] , r13
	st.w	r13 , 16[r6]		/* CPU㳰ȯΥåե饰 */
	
	/* CPU㳰ȯCPUå֤ʤ饢å */
	cmp 	r0 , r13
	be		call_exc_handler
	/*
	 *  TIPM_ENAALLꤹȳߥϥɥȯCPU㳰
	 *  ͥ٤ž뤿ᡤϸߤγͥ٥ޥѤ
	 */
	st.w	r0 , 0[r14]
	add		-8 , sp
	st.w	r10 , 4[sp]
	st.w	r6 , 0[sp]
	Lea		_current_intpri , r6
	ld.bu	0[r6] , r6
	jarl	_set_intpri , lp
	ld.w	4[sp] , r10
	ld.w	0[sp] , r6
	add		8 , sp
call_exc_handler:
#ifdef LOG_EXC_ENTER
	/* CPU㳰ϥɥ饢ɥ쥹㳰ȯSPCPU㳰ֹ */
	add		-12 , sp
	st.w	r10 , 0[sp]
	st.w	r6 , 4[sp]
	st.w	r12 , 8[sp]
	mov		r12 , r6
	ei
	jarl	_log_exc_enter , lp
	di
	ld.w	0[sp] , r10
	ld.w	4[sp] , r6
	ld.w	8[sp] , r12
	add		12 , sp
#endif	/* LOG_EXC_ENTER */
#ifdef LOG_EXC_LEAVE
	add		-4 , sp
	st.w	r12 , 0[sp]
#endif	/* LOG_EXC_LEAVE */
	Lea		end_exc_handler , lp
	/* ϥɥ鵯ư */
	ei
	jmp		r10
end_exc_handler:
	di
#ifdef LOG_EXC_LEAVE
	ld.w	0[sp] , r6
	add		4 , sp
	ei
	jarl	_log_exc_leave , lp
	di
#endif	/* LOG_EXC_LEAVE */
	
	/*
	 *  CPUå֤CPU㳰ȯξ֤᤹
	 */
	ld.w	16[sp] , r10
	Lea		_lock_flag , r11
	st.w	r10 , 0[r11]
	cmp		r0 , r10
	bz		end_exc_handler_1
	mov		INTPRI_LOCK , r6
	jarl	_set_intpri , lp
	
end_exc_handler_1:
	/* CPU㳰ȯξ֤Ǽΰ˴ */
	addi	20 , sp , sp
	/* intnestǥ */
	Lea		_intnest, r11
	ld.bu	0[r11], r10
	add		-1 , r10
	st.b	r10, 0[r11]
	cmp		r0 , r10	
	/* ʹߤ϶̽ */
	be		check_reqflg
	br		return_from_int

/*
 *  ͥνλθƽФ
 */
	.globl _call_exit_kernel
_call_exit_kernel:
	/* 󥿥ƥȤڤؤ */
	mov		STACKTOP , sp
	jarl	_exit_kernel , lp
	/* äƤ뤳ȤϤʤäƤΤ̵¥롼 */
	di
_call_exit_kernel_loop:
	br		_call_exit_kernel_loop


